"use client";
import Button from "@/components/button"
import TypeText from "@/components/typetext";
import BlinkText from "@/components/blinktext";
import Delay from "@/components/delay";
import React from "react";

const names = [
  "citizen",
  "Mikael",
  "Niklas",
  "Anna",
  "Eva",
  "Calle",
  "Emma",
  "Gabriel",
  "Rebecca"
];

export default function Home() {
  React.useEffect(() => {
    const handler = (e: Event) => e.preventDefault();
    document.addEventListener('contextmenu', handler);
    return () => document.removeEventListener('contextmenu', handler);
  }, []);

  const [cycle, setCycle] = React.useState({ index: 0, show: true });
  const [showButton, setShowButton] = React.useState(false);

  return (
    <div className="grid grid-rows-[20px_1fr_20px] items-center justify-items-center min-h-screen p-8 pb-20 gap-16 sm:p-20 font-[family-name:var(--font-orbitron)] select-none">
      <main className="flex flex-col gap-8 row-start-2 items-center">
        <div className="text-2xl lg:text-4xl text-center sm:text-left sm:text-2xl font-[family-name:var(--font-doto)] display-inline">
          <Delay delay={2000}>
            <TypeText interval={75} onComplete={() => { setShowButton(true); }}> Welcome, </TypeText>
            { showButton && <div className="tofvesson-emph inline"><TypeText interval={cycle.show ? 75 : 100} reverse={!cycle.show} onComplete={ () => {
              if (!cycle.show) {
                return setTimeout(setCycle, 200, { index: (cycle.index + 1) % names.length, show: true });
              } else {
                return setTimeout(setCycle, 3000, { index: cycle.index, show: false });
              }
            } }>{`${names[cycle.index]}!`}</TypeText></div> }
          </Delay>
          <div className={`${showButton ? "tofvesson-emph " : ""}inline`}><BlinkText interval={1000}>_</BlinkText></div>
        </div>
        <Button
          border={false}
          invertColors={true}
          className={`${ showButton ? "opacity-100" : "opacity-0 hover:cursor-default"} transition-opacity ease-in-out duration-500 delay-150`}>
          Enter the fun zone
        </Button>
      </main>
    </div>
  );
}
