"use client";
import { ReactNode, useEffect, useState } from "react"

export type BlinkTextProps = { children?: ReactNode, interval: number, props?: React.HTMLAttributes<HTMLDivElement> };
export default function BlinkText({ children, interval, props }: BlinkTextProps) {
  const elementProps = props ? props : {};
  const [show, setShow] = useState(false);
  useEffect(() => {
    const intervalRef = setInterval(() => {
      setShow(!show);
    }, interval);

    return () => clearInterval(intervalRef);
  }, [show, interval]);

  return <div {...elementProps} style={{ visibility: show ? "visible" : "hidden", display: "inline" }}>{children}</div>
}